// AsciiLexerImpl.hpp generated by reflex 4.2.0 from AsciiLexerImpl.l

#define REFLEX_VERSION "4.2.0"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  OPTIONS USED                                                              //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

#undef REFLEX_OPTION_fast
#undef REFLEX_OPTION_lex
#undef REFLEX_OPTION_lexer
#undef REFLEX_OPTION_namespace
#undef REFLEX_OPTION_nodefault
#undef REFLEX_OPTION_noindent
#undef REFLEX_OPTION_noline
#undef REFLEX_OPTION_noyywrap
#undef REFLEX_OPTION_outfile
#undef REFLEX_OPTION_token_type

#define REFLEX_OPTION_fast                true
#define REFLEX_OPTION_lex                 lex
#define REFLEX_OPTION_lexer               AsciiLexerImpl
#define REFLEX_OPTION_namespace           ccl::rslang::detail::asciilex
#define REFLEX_OPTION_nodefault           true
#define REFLEX_OPTION_noindent            true
#define REFLEX_OPTION_noline              true
#define REFLEX_OPTION_noyywrap            true
#define REFLEX_OPTION_outfile             "AsciiLexerImpl.hpp"
#define REFLEX_OPTION_token_type          ccl::rslang::TokenID

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  SECTION 1: %top user code                                                 //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////



#pragma once
#include "ccl/rslang/RSToken.h"



////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  REGEX MATCHER                                                             //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

#define WITH_NO_INDENT
#include <reflex/matcher.h>

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  ABSTRACT LEXER CLASS                                                      //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

#include <reflex/abslexer.h>

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  LEXER CLASS                                                               //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

namespace ccl {
namespace rslang {
namespace detail {
namespace asciilex {

class AsciiLexerImpl : public reflex::AbstractLexer<reflex::Matcher> {

public:
  [[nodiscard]] StrRange Range() const {
   // Note: returning byte position, not code point! Assume input is ASCII
    return StrRange{ static_cast<StrPos>(matcher().first()),
            static_cast<StrPos>(matcher().last()) };
  }

 public:
  typedef reflex::AbstractLexer<reflex::Matcher> AbstractBaseLexer;
  AsciiLexerImpl(
      // a persistent source of input, empty by default
      const reflex::Input& input = reflex::Input(),
      // optional output stream, std::cout by default
      std::ostream& os = std::cout)
    :
      AbstractBaseLexer(input, os)
  {
  }
  static const int INITIAL = 0;
  // the lexer function defined by SECTION 2
  virtual ccl::rslang::TokenID lex(void);
  // lexer functions accepting new input to scan
  ccl::rslang::TokenID lex(const reflex::Input& input)
  {
    in(input);
    return lex();
  }
  ccl::rslang::TokenID lex(const reflex::Input& input, std::ostream *os)
  {
    in(input);
    if (os)
      out(*os);
    return lex();
  }
};

} // namespace ccl
} // namespace rslang
} // namespace detail
} // namespace asciilex

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  SECTION 2: rules                                                          //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

namespace ccl {
namespace rslang {
namespace detail {
namespace asciilex {
extern void reflex_code_INITIAL(reflex::Matcher&);
} // namespace ccl
} // namespace rslang
} // namespace detail
} // namespace asciilex

ccl::rslang::TokenID ccl::rslang::detail::asciilex::AsciiLexerImpl::lex(void)
{
  static const reflex::Pattern PATTERN_INITIAL(reflex_code_INITIAL);
  if (!has_matcher())
  {
    matcher(new Matcher(PATTERN_INITIAL, stdinit(), this));
  }
  while (true)
  {
        switch (matcher().scan())
        {
          case 0:
            if (matcher().at_end())
            {
{ return TokenID::END; }
            }
            else
            {
              lexer_error("scanner jammed");
              return ccl::rslang::TokenID();
            }
            break;
          case 1: // rule AsciiLexerImpl.l:45: "\A" :
{ return TokenID::FORALL; }
            break;
          case 2: // rule AsciiLexerImpl.l:46: "\E" :
{ return TokenID::EXISTS; }

            break;
          case 3: // rule AsciiLexerImpl.l:48: "\neg" :
{ return TokenID::NOT; }
            break;
          case 4: // rule AsciiLexerImpl.l:49: "\and" :
{ return TokenID::AND; }
            break;
          case 5: // rule AsciiLexerImpl.l:50: "\or" :
{ return TokenID::OR; }
            break;
          case 6: // rule AsciiLexerImpl.l:51: "\impl" :
{ return TokenID::IMPLICATION; }
            break;
          case 7: // rule AsciiLexerImpl.l:52: "\equiv" :
{ return TokenID::EQUIVALENT; }

            break;
          case 8: // rule AsciiLexerImpl.l:54: "\plus" :
{ return TokenID::PLUS; }
            break;
          case 9: // rule AsciiLexerImpl.l:55: "\minus" :
{ return TokenID::MINUS; }
            break;
          case 10: // rule AsciiLexerImpl.l:56: "\multiply" :
{ return TokenID::MULTIPLY; }
            break;
          case 11: // rule AsciiLexerImpl.l:57: "\gr" :
{ return TokenID::GREATER; }
            break;
          case 12: // rule AsciiLexerImpl.l:58: "\ls" :
{ return TokenID::LESSER; }
            break;
          case 13: // rule AsciiLexerImpl.l:59: "\ge" :
{ return TokenID::GREATER_OR_EQ; }
            break;
          case 14: // rule AsciiLexerImpl.l:60: "\le" :
{ return TokenID::LESSER_OR_EQ; }

            break;
          case 15: // rule AsciiLexerImpl.l:62: "\eq" :
{ return TokenID::EQUAL; }
            break;
          case 16: // rule AsciiLexerImpl.l:63: "\noteq" :
{ return TokenID::NOTEQUAL; }

            break;
          case 17: // rule AsciiLexerImpl.l:65: "\in" :
{ return TokenID::IN; }
            break;
          case 18: // rule AsciiLexerImpl.l:66: "\notin" :
{ return TokenID::NOTIN; }
            break;
          case 19: // rule AsciiLexerImpl.l:67: "\subseteq" :
{ return TokenID::SUBSET_OR_EQ; }
            break;
          case 20: // rule AsciiLexerImpl.l:68: "\subset" :
{ return TokenID::SUBSET; }
            break;
          case 21: // rule AsciiLexerImpl.l:69: "\notsubset" :
{ return TokenID::NOTSUBSET; }

            break;
          case 22: // rule AsciiLexerImpl.l:71: "*" :
{ return TokenID::DECART; }
            break;
          case 23: // rule AsciiLexerImpl.l:72: "\union" :
{ return TokenID::UNION; }
            break;
          case 24: // rule AsciiLexerImpl.l:73: "\intersect" :
{ return TokenID::INTERSECTION; }
            break;
          case 25: // rule AsciiLexerImpl.l:74: "\setminus" :
{ return TokenID::SET_MINUS; }
            break;
          case 26: // rule AsciiLexerImpl.l:75: "\symmdiff" :
{ return TokenID::SYMMINUS; }
            break;
          case 27: // rule AsciiLexerImpl.l:76: "B" :
{ return TokenID::BOOLEAN; }

            break;
          case 28: // rule AsciiLexerImpl.l:78: pr{index} :
{ return TokenID::SMALLPR; }
            break;
          case 29: // rule AsciiLexerImpl.l:79: Pr{index} :
{ return TokenID::BIGPR; }
            break;
          case 30: // rule AsciiLexerImpl.l:80: Fi{index} :
{ return TokenID::FILTER; }
            break;
          case 31: // rule AsciiLexerImpl.l:81: card :
{ return TokenID::CARD; }
            break;
          case 32: // rule AsciiLexerImpl.l:82: bool :
{ return TokenID::BOOL; }
            break;
          case 33: // rule AsciiLexerImpl.l:83: red :
{ return TokenID::REDUCE; }
            break;
          case 34: // rule AsciiLexerImpl.l:84: debool :
{ return TokenID::DEBOOL; }

            break;
          case 35: // rule AsciiLexerImpl.l:86: D :
{ return TokenID::DECLARATIVE; }
            break;
          case 36: // rule AsciiLexerImpl.l:87: R :
{ return TokenID::RECURSIVE; }
            break;
          case 37: // rule AsciiLexerImpl.l:88: I :
{ return TokenID::IMPERATIVE; }

            break;
          case 38: // rule AsciiLexerImpl.l:90: Z :
{ return TokenID::LIT_INTSET; }
            break;
          case 39: // rule AsciiLexerImpl.l:91: "{}" :
{ return TokenID::LIT_EMPTYSET; }
            break;
          case 40: // rule AsciiLexerImpl.l:92: {number} :
{ return TokenID::LIT_INTEGER; }

            break;
          case 41: // rule AsciiLexerImpl.l:94: F{number} :
{ return TokenID::ID_FUNCTION; }
            break;
          case 42: // rule AsciiLexerImpl.l:95: P{number} :
{ return TokenID::ID_PREDICATE; }
            break;
          case 43: // rule AsciiLexerImpl.l:96: R{number} :
{ return TokenID::ID_RADICAL; }

            break;
          case 44: // rule AsciiLexerImpl.l:98: {global_id} :
{ return TokenID::ID_GLOBAL; }
            break;
          case 45: // rule AsciiLexerImpl.l:99: {local_id} :
{ return TokenID::ID_LOCAL; }

            break;
          case 46: // rule AsciiLexerImpl.l:101: "\assign" :
{ return TokenID::PUNC_ASSIGN; }
            break;
          case 47: // rule AsciiLexerImpl.l:102: "\from" :
{ return TokenID::PUNC_ITERATE; }
            break;
          case 48: // rule AsciiLexerImpl.l:103: "\defexpr" :
{ return TokenID::PUNC_DEFINE; }
            break;
          case 49: // rule AsciiLexerImpl.l:104: "\deftype" :
{ return TokenID::PUNC_STRUCT; }
            break;
          case 50: // rule AsciiLexerImpl.l:105: "(" :
{ return TokenID::PUNC_PL; }
            break;
          case 51: // rule AsciiLexerImpl.l:106: ")" :
{ return TokenID::PUNC_PR; }
            break;
          case 52: // rule AsciiLexerImpl.l:107: "{" :
{ return TokenID::PUNC_CL; }
            break;
          case 53: // rule AsciiLexerImpl.l:108: "}" :
{ return TokenID::PUNC_CR; }
            break;
          case 54: // rule AsciiLexerImpl.l:109: "[" :
{ return TokenID::PUNC_SL; }
            break;
          case 55: // rule AsciiLexerImpl.l:110: "]" :
{ return TokenID::PUNC_SR; }
            break;
          case 56: // rule AsciiLexerImpl.l:111: "|" :
{ return TokenID::PUNC_BAR; }
            break;
          case 57: // rule AsciiLexerImpl.l:112: "," :
{ return TokenID::PUNC_COMMA; }
            break;
          case 58: // rule AsciiLexerImpl.l:113: ";" :
{ return TokenID::PUNC_SEMICOLON; }

            break;
          case 59: // rule AsciiLexerImpl.l:115: {ws} :
;
            break;
          case 60: // rule AsciiLexerImpl.l:117: . :
{ return TokenID::INTERRUPT; }

            break;
        }
  }
}

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  TABLES                                                                    //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

#include <reflex/matcher.h>

#if defined(OS_WIN)
#pragma warning(disable:4101 4102)
#elif defined(__GNUC__)
#pragma GCC diagnostic ignored "-Wunused-variable"
#pragma GCC diagnostic ignored "-Wunused-label"
#elif defined(__clang__)
#pragma clang diagnostic ignored "-Wunused-variable"
#pragma clang diagnostic ignored "-Wunused-label"
#endif

namespace ccl {
namespace rslang {
namespace detail {
namespace asciilex {

void reflex_code_INITIAL(reflex::Matcher& m)
{
  int c0 = 0, c1 = 0;
  m.FSM_INIT(c1);

S0:
  m.FSM_FIND();
  c1 = m.FSM_CHAR();
  if (c1 == '}') goto S148;
  if (c1 == '|') goto S154;
  if (c1 == '{') goto S126;
  if (c1 == 'r') goto S88;
  if (c1 == 'p') goto S53;
  if (c1 == 'd') goto S95;
  if (c1 == 'c') goto S74;
  if (c1 == 'b') goto S81;
  if ('a' <= c1 && c1 <= 'z') goto S138;
  if (c1 == '_') goto S138;
  if (c1 == ']') goto S152;
  if (c1 == '\\') goto S32;
  if (c1 == '[') goto S150;
  if (c1 == 'Z') goto S120;
  if (c1 == 'R') goto S108;
  if (c1 == 'P') goto S60;
  if (c1 == 'I') goto S114;
  if (c1 == 'F') goto S67;
  if (c1 == 'D') goto S102;
  if (c1 == 'B') goto S51;
  if ('A' <= c1 && c1 <= 'Y') goto S132;
  if (c1 == ';') goto S158;
  if ('0' <= c1 && c1 <= '9') goto S129;
  if (c1 == ',') goto S156;
  if (c1 == '*') goto S49;
  if (c1 == ')') goto S146;
  if (c1 == '(') goto S144;
  if (c1 == ' ') goto S165;
  if (c1 == '\r') goto S165;
  if (c1 == '\n') goto S160;
  if (c1 == '\t') goto S165;
  if (0 <= c1) goto S170;
  return m.FSM_HALT(c1);

S32:
  m.FSM_TAKE(60);
  c1 = m.FSM_CHAR();
  if (c1 == 'u') goto S204;
  if (c1 == 's') goto S200;
  if (c1 == 'p') goto S189;
  if (c1 == 'o') goto S182;
  if (c1 == 'n') goto S176;
  if (c1 == 'm') goto S191;
  if (c1 == 'l') goto S197;
  if (c1 == 'i') goto S184;
  if (c1 == 'g') goto S194;
  if (c1 == 'f') goto S206;
  if (c1 == 'e') goto S187;
  if (c1 == 'd') goto S208;
  if (c1 == 'a') goto S179;
  if (c1 == 'E') goto S174;
  if (c1 == 'A') goto S172;
  return m.FSM_HALT(c1);

S49:
  m.FSM_TAKE(22);
  return m.FSM_HALT();

S51:
  m.FSM_TAKE(27);
  return m.FSM_HALT();

S53:
  m.FSM_TAKE(45);
  c1 = m.FSM_CHAR();
  if (c1 == 'r') goto S210;
  if ('a' <= c1 && c1 <= 'z') goto S216;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S216;
  return m.FSM_HALT(c1);

S60:
  m.FSM_TAKE(44);
  c1 = m.FSM_CHAR();
  if (c1 == 'r') goto S222;
  if ('a' <= c1 && c1 <= 'z') goto S234;
  if (c1 == '_') goto S234;
  if ('A' <= c1 && c1 <= 'Z') goto S234;
  if ('0' <= c1 && c1 <= '9') goto S228;
  return m.FSM_HALT(c1);

S67:
  m.FSM_TAKE(44);
  c1 = m.FSM_CHAR();
  if (c1 == 'i') goto S240;
  if ('a' <= c1 && c1 <= 'z') goto S234;
  if (c1 == '_') goto S234;
  if ('A' <= c1 && c1 <= 'Z') goto S234;
  if ('0' <= c1 && c1 <= '9') goto S246;
  return m.FSM_HALT(c1);

S74:
  m.FSM_TAKE(45);
  c1 = m.FSM_CHAR();
  if ('b' <= c1 && c1 <= 'z') goto S216;
  if (c1 == 'a') goto S252;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S216;
  return m.FSM_HALT(c1);

S81:
  m.FSM_TAKE(45);
  c1 = m.FSM_CHAR();
  if (c1 == 'o') goto S259;
  if ('a' <= c1 && c1 <= 'z') goto S216;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S216;
  return m.FSM_HALT(c1);

S88:
  m.FSM_TAKE(45);
  c1 = m.FSM_CHAR();
  if (c1 == 'e') goto S266;
  if ('a' <= c1 && c1 <= 'z') goto S216;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S216;
  return m.FSM_HALT(c1);

S95:
  m.FSM_TAKE(45);
  c1 = m.FSM_CHAR();
  if (c1 == 'e') goto S273;
  if ('a' <= c1 && c1 <= 'z') goto S216;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S216;
  return m.FSM_HALT(c1);

S102:
  m.FSM_TAKE(35);
  c1 = m.FSM_CHAR();
  if ('a' <= c1 && c1 <= 'z') goto S234;
  if (c1 == '_') goto S234;
  if ('A' <= c1 && c1 <= 'Z') goto S234;
  if ('0' <= c1 && c1 <= '9') goto S234;
  return m.FSM_HALT(c1);

S108:
  m.FSM_TAKE(36);
  c1 = m.FSM_CHAR();
  if ('a' <= c1 && c1 <= 'z') goto S234;
  if (c1 == '_') goto S234;
  if ('A' <= c1 && c1 <= 'Z') goto S234;
  if ('0' <= c1 && c1 <= '9') goto S280;
  return m.FSM_HALT(c1);

S114:
  m.FSM_TAKE(37);
  c1 = m.FSM_CHAR();
  if ('a' <= c1 && c1 <= 'z') goto S234;
  if (c1 == '_') goto S234;
  if ('A' <= c1 && c1 <= 'Z') goto S234;
  if ('0' <= c1 && c1 <= '9') goto S234;
  return m.FSM_HALT(c1);

S120:
  m.FSM_TAKE(38);
  c1 = m.FSM_CHAR();
  if ('a' <= c1 && c1 <= 'z') goto S234;
  if (c1 == '_') goto S234;
  if ('A' <= c1 && c1 <= 'Z') goto S234;
  if ('0' <= c1 && c1 <= '9') goto S234;
  return m.FSM_HALT(c1);

S126:
  m.FSM_TAKE(52);
  c1 = m.FSM_CHAR();
  if (c1 == '}') goto S286;
  return m.FSM_HALT(c1);

S129:
  m.FSM_TAKE(40);
  c1 = m.FSM_CHAR();
  if ('0' <= c1 && c1 <= '9') goto S288;
  return m.FSM_HALT(c1);

S132:
  m.FSM_TAKE(44);
  c1 = m.FSM_CHAR();
  if ('a' <= c1 && c1 <= 'z') goto S234;
  if (c1 == '_') goto S234;
  if ('A' <= c1 && c1 <= 'Z') goto S234;
  if ('0' <= c1 && c1 <= '9') goto S234;
  return m.FSM_HALT(c1);

S138:
  m.FSM_TAKE(45);
  c1 = m.FSM_CHAR();
  if ('a' <= c1 && c1 <= 'z') goto S216;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S216;
  return m.FSM_HALT(c1);

S144:
  m.FSM_TAKE(50);
  return m.FSM_HALT();

S146:
  m.FSM_TAKE(51);
  return m.FSM_HALT();

S148:
  m.FSM_TAKE(53);
  return m.FSM_HALT();

S150:
  m.FSM_TAKE(54);
  return m.FSM_HALT();

S152:
  m.FSM_TAKE(55);
  return m.FSM_HALT();

S154:
  m.FSM_TAKE(56);
  return m.FSM_HALT();

S156:
  m.FSM_TAKE(57);
  return m.FSM_HALT();

S158:
  m.FSM_TAKE(58);
  return m.FSM_HALT();

S160:
  m.FSM_TAKE(59);
  c1 = m.FSM_CHAR();
  if (c1 == ' ') goto S160;
  if (c1 == '\r') goto S160;
  if ('\t' <= c1 && c1 <= '\n') goto S160;
  return m.FSM_HALT(c1);

S165:
  m.FSM_TAKE(59);
  c1 = m.FSM_CHAR();
  if (c1 == ' ') goto S160;
  if (c1 == '\r') goto S160;
  if ('\t' <= c1 && c1 <= '\n') goto S160;
  return m.FSM_HALT(c1);

S170:
  m.FSM_TAKE(60);
  return m.FSM_HALT();

S172:
  m.FSM_TAKE(1);
  return m.FSM_HALT();

S174:
  m.FSM_TAKE(2);
  return m.FSM_HALT();

S176:
  c1 = m.FSM_CHAR();
  if (c1 == 'o') goto S293;
  if (c1 == 'e') goto S291;
  return m.FSM_HALT(c1);

S179:
  c1 = m.FSM_CHAR();
  if (c1 == 's') goto S297;
  if (c1 == 'n') goto S295;
  return m.FSM_HALT(c1);

S182:
  c1 = m.FSM_CHAR();
  if (c1 == 'r') goto S299;
  return m.FSM_HALT(c1);

S184:
  c1 = m.FSM_CHAR();
  if (c1 == 'n') goto S303;
  if (c1 == 'm') goto S301;
  return m.FSM_HALT(c1);

S187:
  c1 = m.FSM_CHAR();
  if (c1 == 'q') goto S306;
  return m.FSM_HALT(c1);

S189:
  c1 = m.FSM_CHAR();
  if (c1 == 'l') goto S309;
  return m.FSM_HALT(c1);

S191:
  c1 = m.FSM_CHAR();
  if (c1 == 'u') goto S313;
  if (c1 == 'i') goto S311;
  return m.FSM_HALT(c1);

S194:
  c1 = m.FSM_CHAR();
  if (c1 == 'r') goto S315;
  if (c1 == 'e') goto S317;
  return m.FSM_HALT(c1);

S197:
  c1 = m.FSM_CHAR();
  if (c1 == 's') goto S319;
  if (c1 == 'e') goto S321;
  return m.FSM_HALT(c1);

S200:
  c1 = m.FSM_CHAR();
  if (c1 == 'y') goto S327;
  if (c1 == 'u') goto S323;
  if (c1 == 'e') goto S325;
  return m.FSM_HALT(c1);

S204:
  c1 = m.FSM_CHAR();
  if (c1 == 'n') goto S329;
  return m.FSM_HALT(c1);

S206:
  c1 = m.FSM_CHAR();
  if (c1 == 'r') goto S331;
  return m.FSM_HALT(c1);

S208:
  c1 = m.FSM_CHAR();
  if (c1 == 'e') goto S333;
  return m.FSM_HALT(c1);

S210:
  m.FSM_TAKE(45);
  c1 = m.FSM_CHAR();
  if ('a' <= c1 && c1 <= 'z') goto S216;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S335;
  return m.FSM_HALT(c1);

S216:
  m.FSM_TAKE(45);
  c1 = m.FSM_CHAR();
  if ('a' <= c1 && c1 <= 'z') goto S216;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S216;
  return m.FSM_HALT(c1);

S222:
  m.FSM_TAKE(44);
  c1 = m.FSM_CHAR();
  if ('a' <= c1 && c1 <= 'z') goto S234;
  if (c1 == '_') goto S234;
  if ('A' <= c1 && c1 <= 'Z') goto S234;
  if ('0' <= c1 && c1 <= '9') goto S342;
  return m.FSM_HALT(c1);

S228:
  m.FSM_TAKE(42);
  c1 = m.FSM_CHAR();
  if ('a' <= c1 && c1 <= 'z') goto S234;
  if (c1 == '_') goto S234;
  if ('A' <= c1 && c1 <= 'Z') goto S234;
  if ('0' <= c1 && c1 <= '9') goto S228;
  return m.FSM_HALT(c1);

S234:
  m.FSM_TAKE(44);
  c1 = m.FSM_CHAR();
  if ('a' <= c1 && c1 <= 'z') goto S234;
  if (c1 == '_') goto S234;
  if ('A' <= c1 && c1 <= 'Z') goto S234;
  if ('0' <= c1 && c1 <= '9') goto S234;
  return m.FSM_HALT(c1);

S240:
  m.FSM_TAKE(44);
  c1 = m.FSM_CHAR();
  if ('a' <= c1 && c1 <= 'z') goto S234;
  if (c1 == '_') goto S234;
  if ('A' <= c1 && c1 <= 'Z') goto S234;
  if ('0' <= c1 && c1 <= '9') goto S349;
  return m.FSM_HALT(c1);

S246:
  m.FSM_TAKE(41);
  c1 = m.FSM_CHAR();
  if ('a' <= c1 && c1 <= 'z') goto S234;
  if (c1 == '_') goto S234;
  if ('A' <= c1 && c1 <= 'Z') goto S234;
  if ('0' <= c1 && c1 <= '9') goto S246;
  return m.FSM_HALT(c1);

S252:
  m.FSM_TAKE(45);
  c1 = m.FSM_CHAR();
  if (c1 == 'r') goto S356;
  if ('a' <= c1 && c1 <= 'z') goto S216;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S216;
  return m.FSM_HALT(c1);

S259:
  m.FSM_TAKE(45);
  c1 = m.FSM_CHAR();
  if (c1 == 'o') goto S363;
  if ('a' <= c1 && c1 <= 'z') goto S216;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S216;
  return m.FSM_HALT(c1);

S266:
  m.FSM_TAKE(45);
  c1 = m.FSM_CHAR();
  if (c1 == 'd') goto S370;
  if ('a' <= c1 && c1 <= 'z') goto S216;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S216;
  return m.FSM_HALT(c1);

S273:
  m.FSM_TAKE(45);
  c1 = m.FSM_CHAR();
  if (c1 == 'b') goto S376;
  if ('a' <= c1 && c1 <= 'z') goto S216;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S216;
  return m.FSM_HALT(c1);

S280:
  m.FSM_TAKE(43);
  c1 = m.FSM_CHAR();
  if ('a' <= c1 && c1 <= 'z') goto S234;
  if (c1 == '_') goto S234;
  if ('A' <= c1 && c1 <= 'Z') goto S234;
  if ('0' <= c1 && c1 <= '9') goto S280;
  return m.FSM_HALT(c1);

S286:
  m.FSM_TAKE(39);
  return m.FSM_HALT();

S288:
  m.FSM_TAKE(40);
  c1 = m.FSM_CHAR();
  if ('0' <= c1 && c1 <= '9') goto S288;
  return m.FSM_HALT(c1);

S291:
  c1 = m.FSM_CHAR();
  if (c1 == 'g') goto S383;
  return m.FSM_HALT(c1);

S293:
  c1 = m.FSM_CHAR();
  if (c1 == 't') goto S385;
  return m.FSM_HALT(c1);

S295:
  c1 = m.FSM_CHAR();
  if (c1 == 'd') goto S389;
  return m.FSM_HALT(c1);

S297:
  c1 = m.FSM_CHAR();
  if (c1 == 's') goto S391;
  return m.FSM_HALT(c1);

S299:
  m.FSM_TAKE(5);
  return m.FSM_HALT();

S301:
  c1 = m.FSM_CHAR();
  if (c1 == 'p') goto S393;
  return m.FSM_HALT(c1);

S303:
  m.FSM_TAKE(17);
  c1 = m.FSM_CHAR();
  if (c1 == 't') goto S395;
  return m.FSM_HALT(c1);

S306:
  m.FSM_TAKE(15);
  c1 = m.FSM_CHAR();
  if (c1 == 'u') goto S397;
  return m.FSM_HALT(c1);

S309:
  c1 = m.FSM_CHAR();
  if (c1 == 'u') goto S399;
  return m.FSM_HALT(c1);

S311:
  c1 = m.FSM_CHAR();
  if (c1 == 'n') goto S401;
  return m.FSM_HALT(c1);

S313:
  c1 = m.FSM_CHAR();
  if (c1 == 'l') goto S403;
  return m.FSM_HALT(c1);

S315:
  m.FSM_TAKE(11);
  return m.FSM_HALT();

S317:
  m.FSM_TAKE(13);
  return m.FSM_HALT();

S319:
  m.FSM_TAKE(12);
  return m.FSM_HALT();

S321:
  m.FSM_TAKE(14);
  return m.FSM_HALT();

S323:
  c1 = m.FSM_CHAR();
  if (c1 == 'b') goto S405;
  return m.FSM_HALT(c1);

S325:
  c1 = m.FSM_CHAR();
  if (c1 == 't') goto S407;
  return m.FSM_HALT(c1);

S327:
  c1 = m.FSM_CHAR();
  if (c1 == 'm') goto S409;
  return m.FSM_HALT(c1);

S329:
  c1 = m.FSM_CHAR();
  if (c1 == 'i') goto S411;
  return m.FSM_HALT(c1);

S331:
  c1 = m.FSM_CHAR();
  if (c1 == 'o') goto S413;
  return m.FSM_HALT(c1);

S333:
  c1 = m.FSM_CHAR();
  if (c1 == 'f') goto S415;
  return m.FSM_HALT(c1);

S335:
  m.FSM_TAKE(28);
  c1 = m.FSM_CHAR();
  if ('a' <= c1 && c1 <= 'z') goto S216;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S335;
  if (c1 == ',') goto S418;
  return m.FSM_HALT(c1);

S342:
  m.FSM_TAKE(29);
  c1 = m.FSM_CHAR();
  if ('a' <= c1 && c1 <= 'z') goto S234;
  if (c1 == '_') goto S234;
  if ('A' <= c1 && c1 <= 'Z') goto S234;
  if ('0' <= c1 && c1 <= '9') goto S342;
  if (c1 == ',') goto S420;
  return m.FSM_HALT(c1);

S349:
  m.FSM_TAKE(30);
  c1 = m.FSM_CHAR();
  if ('a' <= c1 && c1 <= 'z') goto S234;
  if (c1 == '_') goto S234;
  if ('A' <= c1 && c1 <= 'Z') goto S234;
  if ('0' <= c1 && c1 <= '9') goto S349;
  if (c1 == ',') goto S422;
  return m.FSM_HALT(c1);

S356:
  m.FSM_TAKE(45);
  c1 = m.FSM_CHAR();
  if (c1 == 'd') goto S424;
  if ('a' <= c1 && c1 <= 'z') goto S216;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S216;
  return m.FSM_HALT(c1);

S363:
  m.FSM_TAKE(45);
  c1 = m.FSM_CHAR();
  if (c1 == 'l') goto S430;
  if ('a' <= c1 && c1 <= 'z') goto S216;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S216;
  return m.FSM_HALT(c1);

S370:
  m.FSM_TAKE(33);
  c1 = m.FSM_CHAR();
  if ('a' <= c1 && c1 <= 'z') goto S216;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S216;
  return m.FSM_HALT(c1);

S376:
  m.FSM_TAKE(45);
  c1 = m.FSM_CHAR();
  if (c1 == 'o') goto S436;
  if ('a' <= c1 && c1 <= 'z') goto S216;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S216;
  return m.FSM_HALT(c1);

S383:
  m.FSM_TAKE(3);
  return m.FSM_HALT();

S385:
  c1 = m.FSM_CHAR();
  if (c1 == 's') goto S447;
  if (c1 == 'i') goto S445;
  if (c1 == 'e') goto S443;
  return m.FSM_HALT(c1);

S389:
  m.FSM_TAKE(4);
  return m.FSM_HALT();

S391:
  c1 = m.FSM_CHAR();
  if (c1 == 'i') goto S449;
  return m.FSM_HALT(c1);

S393:
  c1 = m.FSM_CHAR();
  if (c1 == 'l') goto S451;
  return m.FSM_HALT(c1);

S395:
  c1 = m.FSM_CHAR();
  if (c1 == 'e') goto S453;
  return m.FSM_HALT(c1);

S397:
  c1 = m.FSM_CHAR();
  if (c1 == 'i') goto S455;
  return m.FSM_HALT(c1);

S399:
  c1 = m.FSM_CHAR();
  if (c1 == 's') goto S457;
  return m.FSM_HALT(c1);

S401:
  c1 = m.FSM_CHAR();
  if (c1 == 'u') goto S459;
  return m.FSM_HALT(c1);

S403:
  c1 = m.FSM_CHAR();
  if (c1 == 't') goto S461;
  return m.FSM_HALT(c1);

S405:
  c1 = m.FSM_CHAR();
  if (c1 == 's') goto S463;
  return m.FSM_HALT(c1);

S407:
  c1 = m.FSM_CHAR();
  if (c1 == 'm') goto S465;
  return m.FSM_HALT(c1);

S409:
  c1 = m.FSM_CHAR();
  if (c1 == 'm') goto S467;
  return m.FSM_HALT(c1);

S411:
  c1 = m.FSM_CHAR();
  if (c1 == 'o') goto S469;
  return m.FSM_HALT(c1);

S413:
  c1 = m.FSM_CHAR();
  if (c1 == 'm') goto S471;
  return m.FSM_HALT(c1);

S415:
  c1 = m.FSM_CHAR();
  if (c1 == 't') goto S475;
  if (c1 == 'e') goto S473;
  return m.FSM_HALT(c1);

S418:
  c1 = m.FSM_CHAR();
  if ('0' <= c1 && c1 <= '9') goto S477;
  return m.FSM_HALT(c1);

S420:
  c1 = m.FSM_CHAR();
  if ('0' <= c1 && c1 <= '9') goto S481;
  return m.FSM_HALT(c1);

S422:
  c1 = m.FSM_CHAR();
  if ('0' <= c1 && c1 <= '9') goto S485;
  return m.FSM_HALT(c1);

S424:
  m.FSM_TAKE(31);
  c1 = m.FSM_CHAR();
  if ('a' <= c1 && c1 <= 'z') goto S216;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S216;
  return m.FSM_HALT(c1);

S430:
  m.FSM_TAKE(32);
  c1 = m.FSM_CHAR();
  if ('a' <= c1 && c1 <= 'z') goto S216;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S216;
  return m.FSM_HALT(c1);

S436:
  m.FSM_TAKE(45);
  c1 = m.FSM_CHAR();
  if (c1 == 'o') goto S489;
  if ('a' <= c1 && c1 <= 'z') goto S216;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S216;
  return m.FSM_HALT(c1);

S443:
  c1 = m.FSM_CHAR();
  if (c1 == 'q') goto S496;
  return m.FSM_HALT(c1);

S445:
  c1 = m.FSM_CHAR();
  if (c1 == 'n') goto S498;
  return m.FSM_HALT(c1);

S447:
  c1 = m.FSM_CHAR();
  if (c1 == 'u') goto S500;
  return m.FSM_HALT(c1);

S449:
  c1 = m.FSM_CHAR();
  if (c1 == 'g') goto S502;
  return m.FSM_HALT(c1);

S451:
  m.FSM_TAKE(6);
  return m.FSM_HALT();

S453:
  c1 = m.FSM_CHAR();
  if (c1 == 'r') goto S504;
  return m.FSM_HALT(c1);

S455:
  c1 = m.FSM_CHAR();
  if (c1 == 'v') goto S506;
  return m.FSM_HALT(c1);

S457:
  m.FSM_TAKE(8);
  return m.FSM_HALT();

S459:
  c1 = m.FSM_CHAR();
  if (c1 == 's') goto S508;
  return m.FSM_HALT(c1);

S461:
  c1 = m.FSM_CHAR();
  if (c1 == 'i') goto S510;
  return m.FSM_HALT(c1);

S463:
  c1 = m.FSM_CHAR();
  if (c1 == 'e') goto S512;
  return m.FSM_HALT(c1);

S465:
  c1 = m.FSM_CHAR();
  if (c1 == 'i') goto S514;
  return m.FSM_HALT(c1);

S467:
  c1 = m.FSM_CHAR();
  if (c1 == 'd') goto S516;
  return m.FSM_HALT(c1);

S469:
  c1 = m.FSM_CHAR();
  if (c1 == 'n') goto S518;
  return m.FSM_HALT(c1);

S471:
  m.FSM_TAKE(47);
  return m.FSM_HALT();

S473:
  c1 = m.FSM_CHAR();
  if (c1 == 'x') goto S520;
  return m.FSM_HALT(c1);

S475:
  c1 = m.FSM_CHAR();
  if (c1 == 'y') goto S522;
  return m.FSM_HALT(c1);

S477:
  m.FSM_TAKE(28);
  c1 = m.FSM_CHAR();
  if ('0' <= c1 && c1 <= '9') goto S477;
  if (c1 == ',') goto S418;
  return m.FSM_HALT(c1);

S481:
  m.FSM_TAKE(29);
  c1 = m.FSM_CHAR();
  if ('0' <= c1 && c1 <= '9') goto S481;
  if (c1 == ',') goto S420;
  return m.FSM_HALT(c1);

S485:
  m.FSM_TAKE(30);
  c1 = m.FSM_CHAR();
  if ('0' <= c1 && c1 <= '9') goto S485;
  if (c1 == ',') goto S422;
  return m.FSM_HALT(c1);

S489:
  m.FSM_TAKE(45);
  c1 = m.FSM_CHAR();
  if (c1 == 'l') goto S524;
  if ('a' <= c1 && c1 <= 'z') goto S216;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S216;
  return m.FSM_HALT(c1);

S496:
  m.FSM_TAKE(16);
  return m.FSM_HALT();

S498:
  m.FSM_TAKE(18);
  return m.FSM_HALT();

S500:
  c1 = m.FSM_CHAR();
  if (c1 == 'b') goto S530;
  return m.FSM_HALT(c1);

S502:
  c1 = m.FSM_CHAR();
  if (c1 == 'n') goto S532;
  return m.FSM_HALT(c1);

S504:
  c1 = m.FSM_CHAR();
  if (c1 == 's') goto S534;
  return m.FSM_HALT(c1);

S506:
  m.FSM_TAKE(7);
  return m.FSM_HALT();

S508:
  m.FSM_TAKE(9);
  return m.FSM_HALT();

S510:
  c1 = m.FSM_CHAR();
  if (c1 == 'p') goto S536;
  return m.FSM_HALT(c1);

S512:
  c1 = m.FSM_CHAR();
  if (c1 == 't') goto S538;
  return m.FSM_HALT(c1);

S514:
  c1 = m.FSM_CHAR();
  if (c1 == 'n') goto S541;
  return m.FSM_HALT(c1);

S516:
  c1 = m.FSM_CHAR();
  if (c1 == 'i') goto S543;
  return m.FSM_HALT(c1);

S518:
  m.FSM_TAKE(23);
  return m.FSM_HALT();

S520:
  c1 = m.FSM_CHAR();
  if (c1 == 'p') goto S545;
  return m.FSM_HALT(c1);

S522:
  c1 = m.FSM_CHAR();
  if (c1 == 'p') goto S547;
  return m.FSM_HALT(c1);

S524:
  m.FSM_TAKE(34);
  c1 = m.FSM_CHAR();
  if ('a' <= c1 && c1 <= 'z') goto S216;
  if (c1 == '_') goto S216;
  if ('A' <= c1 && c1 <= 'Z') goto S216;
  if ('0' <= c1 && c1 <= '9') goto S216;
  return m.FSM_HALT(c1);

S530:
  c1 = m.FSM_CHAR();
  if (c1 == 's') goto S549;
  return m.FSM_HALT(c1);

S532:
  m.FSM_TAKE(46);
  return m.FSM_HALT();

S534:
  c1 = m.FSM_CHAR();
  if (c1 == 'e') goto S551;
  return m.FSM_HALT(c1);

S536:
  c1 = m.FSM_CHAR();
  if (c1 == 'l') goto S553;
  return m.FSM_HALT(c1);

S538:
  m.FSM_TAKE(20);
  c1 = m.FSM_CHAR();
  if (c1 == 'e') goto S555;
  return m.FSM_HALT(c1);

S541:
  c1 = m.FSM_CHAR();
  if (c1 == 'u') goto S557;
  return m.FSM_HALT(c1);

S543:
  c1 = m.FSM_CHAR();
  if (c1 == 'f') goto S559;
  return m.FSM_HALT(c1);

S545:
  c1 = m.FSM_CHAR();
  if (c1 == 'r') goto S561;
  return m.FSM_HALT(c1);

S547:
  c1 = m.FSM_CHAR();
  if (c1 == 'e') goto S563;
  return m.FSM_HALT(c1);

S549:
  c1 = m.FSM_CHAR();
  if (c1 == 'e') goto S565;
  return m.FSM_HALT(c1);

S551:
  c1 = m.FSM_CHAR();
  if (c1 == 'c') goto S567;
  return m.FSM_HALT(c1);

S553:
  c1 = m.FSM_CHAR();
  if (c1 == 'y') goto S569;
  return m.FSM_HALT(c1);

S555:
  c1 = m.FSM_CHAR();
  if (c1 == 'q') goto S571;
  return m.FSM_HALT(c1);

S557:
  c1 = m.FSM_CHAR();
  if (c1 == 's') goto S573;
  return m.FSM_HALT(c1);

S559:
  c1 = m.FSM_CHAR();
  if (c1 == 'f') goto S575;
  return m.FSM_HALT(c1);

S561:
  m.FSM_TAKE(48);
  return m.FSM_HALT();

S563:
  m.FSM_TAKE(49);
  return m.FSM_HALT();

S565:
  c1 = m.FSM_CHAR();
  if (c1 == 't') goto S577;
  return m.FSM_HALT(c1);

S567:
  c1 = m.FSM_CHAR();
  if (c1 == 't') goto S579;
  return m.FSM_HALT(c1);

S569:
  m.FSM_TAKE(10);
  return m.FSM_HALT();

S571:
  m.FSM_TAKE(19);
  return m.FSM_HALT();

S573:
  m.FSM_TAKE(25);
  return m.FSM_HALT();

S575:
  m.FSM_TAKE(26);
  return m.FSM_HALT();

S577:
  m.FSM_TAKE(21);
  return m.FSM_HALT();

S579:
  m.FSM_TAKE(24);
  return m.FSM_HALT();
}

} // namespace ccl

} // namespace rslang

} // namespace detail

} // namespace asciilex

